#!/usr/bin/perl -T

$yeempcfgdir = '/home/deekoo/.yeempbbs/';
if (stat($yeempcfgdir.'default.cfg')) {
  require $yeempcfgdir.'default.cfg';
} else {
  &fatalerror("Unable to open ${yeempcfgdir}default.cfg");
}

use CGI;

$query = new CGI;

$base=$query->param('base');

if ($base =~ /^([-\/\w]+)$/) {
  $base = $1;
} else {
  foreach $c (sort grep /\w/, map { chr() } 0..255) {
    $wordchars=$wordchars.$c;
  }
  &fatalerror("Bad characters in name of message base '$base'.",
    "<P>Only -, /, and $wordchars are permitted in message-base
    names.</P>");
}
if (stat($yeempcfgdir.$base.'.cfg')) {
  require $yeempcfgdir.$base.'.cfg';
} else {
  &fatalerror("Unable to open '$yeempcfgdir$base.cfg'.",
    "Make sure the base exists and is capitalized properly - filenames are
    usually case-sensitive, so 'Main' and 'main' are NOT the same.</P>");
}

$action = $query->param('action');

if ($action eq 'post') {
  open(FILE,"<$yeempcfgdir$base.post") or
    &fatalerror("Unable to open $yeempcfgdir$base.post");
  undef($/);
  $text = <FILE>;
  close(FILE);
  open(FILE,"<$yeempcfgdir$base.high") or
    &fatalerror("Unable to open $yeempcfgdir$base.high");
  $num = <FILE>;
  close(FILE);
  if ($num =~ /^([0-9]+)$/) {
    $num = $1+1;
  } else {
      &fatalerror("Invalid number '$num'");
  }
  $email = &escape($query->param('email'));
  $subject = &escape($query->param('subject'));
  $identificator = &escape($query->param('identificator'));
  if ($identificator eq '') {
    &fatalerror('Identificator is a required field.');
  }
  $origemail = &escape($query->param('origemail'));
  $origfrom = &escape($query->param('origfrom'));
  $origsubject = &escape($query->param('origsubject'));
  $body = $query->param('body');
  if ($rewrap_body) {
    @body=split(/[\n\r]/,$body);
    $body='';
    foreach $bodyline (@body) {
      if (($bodyline=~/^>/) || ($bodyline eq '')) {
        $body=$body.$bodyline."\n";
      } else {
        if (length($bodyline)>72) {
          @bodyline=split(' ',$bodyline);
          $bodyline='';
          foreach $bodyword (@bodyline) {
            if (length($bodyline)+length($bodyword)<72) {
              $bodyline=$bodyline.' '.$bodyword;
            } else {
              $body=$body.$bodyline."\n";
              $bodyline=$bodyword;
            }
          }
        }
        $body=$body.$bodyline."\n";
      }
    }
  }
  $body=&escape($body);
  if ($filterbannedstrings) {
    foreach $word (keys(%bannedstrings)) {
      if ($body =~ /$word/s) {
        &fatalerror("$censoredmessage<P>$bannedstrings{$word}</P>");
	die;
      }
    }
  }
  if ($linkifyurls) {
    $body2 = $body;
    while ($body=~/([a-z][a-z\d]+:\/\/((.*?)\@|)[-\w\/.:]+)($|[<>\&;'"\r\n])/s) {
      $url = $1;
      $body2 =~ s/$url/<A HREF="$url">$url<\/A>/s;
      $body =~ s/$url//s;
    }
    $body = $body2;
  }
  &add_threading();
  $text = &expand_mcis($text);
  while (open(FILE,"<$messagedir$num.html"))  {
    $num = $num+1;
    close(FILE);
  }
  open(FILE,">$yeempcfgdir$base.high") or
    &fatalerror("Unable to write to $yeempcfgdir$base.high");;
  print FILE $num;
  close(FILE);
  open(FILE,">>$messagedir$num.html") or
    &fatalerror("Unable to save post to $messagedir$num.html.  Please
      report this bug.");
  print FILE "$text\n";
  close(FILE);
  open(FILE,"<$messagedir".'index.html') or &fatalerror('Unable to open
    '.$messagedir.$index.'.html');
  $_ = <FILE>;
  close(FILE);
  if ( /(.*?)<!-- add here -->(.*)$/s ) {
    open(FILE,">$messagedir".'index.html') or &fatalerror('Unable to open 
'.$messagedir.'index.html');
    $FILEsuffix = $2;
    print FILE $1;
    print FILE "<P>";
    if ($email) {
      print FILE "<A HREF=\"mailto:$email\">";
    }
    print FILE $query->param('identificator');
    if ($email) { print FILE "</A>" }
    print FILE " &nbsp;&nbsp;&nbsp; ";
    print FILE "<A HREF=\"$num.html\">";
    print FILE $query->param('subject');
    print FILE "</A></P>\n<!-- add here -->$FILEsuffix";
    close(FILE);
    print "Location: $messageurl$num.html\n";
    print "URI: $messageurl$num.html\n\n";
  }
} elsif ($action eq 'reply') {
  $post = $query->param('post');
  open (FILE,"<$messagedir$post.html") or
    &fatalerror("Unable to read $messagedir$post.html");
  undef($/);
  $text = <FILE>;
  close(FILE);
  if ($text =~ /\<!-- subject --\>(.*?)\<!-- \/subject --\>/s ) {
    $subject = &unescape($1);
    $origsubject = $subject;
    $_ = $subject;
    if ( /^Re:/i ) {
      $subject =~ s/^Re:/Re:/i;
    } else {
      $subject = 'Re: '.$subject;
    }
  }
  if ($text =~ /\<!-- from --\>(.*?)\<!-- \/from --\>/s ) {
    $origfrom = &unescape($1);
  }
  if ($text =~ /\<!-- email --\>(.*?)\<!-- \/email --\>/s ) {
    $origemail = &unescape($1);
  }
  if ($text =~ /\<!-- body --\>(.*?)\<!-- \/body --\>/s ) {
    $body = $1;
    # Strip HTML from the body.  Necessary in case it was linkified.
    $body =~ s/<(?!BR)(.*?)>//gsi;
    $body = &unescape($body);
    $body =~ s/(\n$|$)/\n/s;
    $body =~ s/(.*?)[\n]/>$1/gs;
  }
  open(FILE,"<$yeempcfgdir$base.reply") or
    &fatalerror("Unable to read $yeempcfgdir$base.reply");
  undef($/);
  $text = <FILE>;
  close(FILE);
  print "Content-type: text/html\n\n";
  print &expand_mcis($text);
} else {
  &fatalerror("Invalid action '$action'");
}

sub fatalerror() {
  print "Content-type: text/html\n\n<HTML><BODY bgcolor=\"#000000\"
text=\"#ff0000\"><H3>$_[0]</H3><P>$_[1]</P></BODY></HTML>\n";
  die $_[0];
}

sub escape () {
  $_[0] =~ s/&/&amp;/gs;
  $_[0] =~ s/</&lt;/gs;
  $_[0] =~ s/>/&gt;/gs;
  $_[0] =~ s/\n/<BR>/gs;
  $_[0] =~ s/  / &nbsp;/gs;
  $_[0] =~ s/%([a-z:]+)%/% $1 %/gs;	# Prevents attempts to do obnoxious
					# things w/MCI codes.
  return $_[0];
}

sub unescape () {
  $temp = $_[0];
  $temp =~ s/\<BR\>/\n/gs;
  $temp =~ s/&lt;/</gs;
  $temp =~ s/&gt;/>/gs;
  $temp =~ s/&nbsp;/ /gs;
  $temp =~ s/&amp;/&/gs;
  return $temp;
}

sub expand_mcis() {
  $temp = $_[0];
  $temp =~ s/%subject%/$subject/gs;
  $temp =~ s/%identificator%/$identificator/gs;
  $temp =~ s/%email%/$email/gs;
  $temp =~ s/%replyurl%/$cgiurl?base=$base&action=reply&post=$num/gs;
  $temp =~ s/%cgiurl%/$cgiurl/gs;
  $temp =~ s/%base%/$base/gs;
  $temp =~ s/%noreplies%/$noreplystring/gs;
  if ($orig) {
    $temp =~ s/%previous%/$previous/gs;
  } else {
    $temp =~ s/%previous%//gs;
  }
  $temp =~ s/%origfrom%/$origfrom/gs;
  $temp =~ s/%origemail%/$origemail/gs;
  $temp =~ s/%origsubject%/$origsubject/gs;
  $temp =~ s/%orig%/$post/gs;
  while ($temp=~/%if:(.*?)%(.*?)%endif%/s) {
    $var = $1;
    $data = $2;
    $val = $query->param($var);
    if ((defined($val))&&($val ne '')) {
      $temp =~ s/%if:$var%(.*?)%endif%/$data/s;
    } else {
      $temp =~ s/%if:$var%(.*?)%endif%//sg;
    }
  }
  $temp =~ s/%body%/$body/gs;
  return $temp;
}

sub add_threading() {
  # Open the original and add a reply
  $orig = $query->param('orig');
  if (!$post) { $post = $orig; }
  open (LOG, ">>$messagedir/log");
  print LOG $orig;


  if ($orig ne '') {
    if ($orig =~ /^([0-9]+)$/) {
      $orig = $1;
    } else {
      &fatalerror("Invalid original post number '$orig'");
    }
    open (ORIG,"<$messagedir/$orig.html") or &fatalerror('Unable to open
      original message. "'.$messagedir/$orig.html.'"');
    undef($/);
    $_ = <ORIG>;
    close(ORIG);
    if ( /(.*?)\<!-- \/replies --\>(.*?)$/s ) {
      $neworigposthtml = $1;
      $suffix = $2;
	print LOG "/$suffix/replies\n";
      $neworigposthtml =~ 
        s/\<!-- noreplies --\>(.*?)\<!-- \/noreplies --\>/$replies/sg;
      if ($email) {
        $neworigposthtml = $neworigposthtml."<P><A HREF=\"mailto:$email\">";
      }
      $neworigposthtml = $neworigposthtml.$identificator;
      if ($email) {
        $neworigposthtml = $neworigposthtml.'</A>';
      }
      $neworigposthtml = $neworigposthtml.' <A HREF="'.$num.'.html">'.
        $subject.'</A></P><!-- /replies -->'.$suffix;
      open (ORIG,">$messagedir/$orig.html") or &fatalerror('Unable to open
        original message "'."$messagedir/$orig.html.");
      print ORIG $neworigposthtml;
      close(ORIG);
    }
  }
}
